/* -------------------------------------------------------------------------- *
 * file:         scanlogin.c                                                  *
 * purpose:      provides the nessus server login settings                    *
 * ---------------------------------------------------------------------------*/

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <cgic.h>
/* ip conversion routines and ping require the following header files */
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <netdb.h>
#include "nessuswc.h"

char * get_dns_name(char *remote_ip) {

   struct in_addr	addr;
   struct hostent	*host;

   addr.s_addr = inet_addr(remote_ip);
   host = gethostbyaddr((char *)&addr, sizeof(addr), AF_INET);

   if (h_errno == 0) return (host->h_name);
   else if (h_errno == 1) return ("DNS: Authoritative Answer Host not found");
   else if (h_errno == 2) return ("DNS: Non-Authoritative Host not found");
   else if (h_errno == 3) return ("DNS: Non recoverable errors");
   else if (h_errno == 4) return ("DNS: Valid name, no data record");
   else return ("DNS: Unknown error occured");
}


int cgiMain() {

   static char 	title[] = "Scanner Login";
   char		nessusd_ip[16] = NESSUSD_IP;
   int		nessusd_port = NESSUSD_PORT;
   char		nessusd_user[81] = USERNAME;
   char		nessusd_pass[81] = PASSWORD;
   char		nessusd_cert[81] = CLIENT_CERT;

/* -------------------------------------------------------------------------- *
 * start the html output                                                      *
 * ---------------------------------------------------------------------------*/

   pagehead(title, NULL, cgiOut);

/* -------------------------------------------------------------------------- *
 * start the form output                                                      *
 * ---------------------------------------------------------------------------*/

   fprintf(cgiOut, "<p><center>");
   fprintf(cgiOut, "<table border=\"1\" cellspacing=\"0\" ");
   fprintf(cgiOut, "cellpadding=\"2\" width=\"540\">");
   fprintf(cgiOut, "<form action=\"scanconfig.cgi\" method=\"post\">");
   fprintf(cgiOut, "<tr>\n");
   fprintf(cgiOut, "<td bgcolor=\"#000080\" align=\"center\" colspan=2>");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "Nessus Scanner Daemon");
   fprintf(cgiOut, "</font>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "</tr>");
   fprintf(cgiOut, "<tr>\n");
   fprintf(cgiOut, "<td align=\"center\" bgcolor=\"#CFCFCF\"");
   fprintf(cgiOut, " bordercolor=CFCFCF width=180>");
   fprintf(cgiOut, "IP Address:");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=text name=nessusd-ip size=24 maxlength=24");
   fprintf(cgiOut, " value=%s>\n", nessusd_ip);
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "</tr>");
   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<td align=\"center\" bgcolor=CFCFCF bordercolor=CFCFCF>");
   fprintf(cgiOut, "Nessus Port:");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=text name=nessusd-port size=4 maxlength=5");
   fprintf(cgiOut, " value=%d>\n", nessusd_port);
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "</tr>\n");
   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<td align=\"center\" bgcolor=CFCFCF bordercolor=CFCFCF>");
   fprintf(cgiOut, "Encryption:");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<select name=\"nessusd-encr\">");
   fprintf(cgiOut, "<option value=\"TLSv1\">TLSv1</option>");
   fprintf(cgiOut, "<option value=\"SSLv2\">SSLv2</option>");
   fprintf(cgiOut, "<option value=\"SSLv3\" selected>SSLv3</option>");
   fprintf(cgiOut, "<option value=\"Auto\">Auto</option></select>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "</tr>\n");
   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<td align=\"center\" bgcolor=CFCFCF bordercolor=CFCFCF>");
   fprintf(cgiOut, "User Name:");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=text name=nessusd-user size=24 maxlength=24");
   fprintf(cgiOut, " value=%s>\n", nessusd_user);
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "</tr>\n");
   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<td align=\"center\" bgcolor=CFCFCF bordercolor=CFCFCF>");
   fprintf(cgiOut, "Password: ");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<input type=password name=nessusd-pass size=24 maxlength=24");
   fprintf(cgiOut, " value=%s>\n", nessusd_pass);
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "</tr>\n");
   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<td align=\"center\" bgcolor=CFCFCF bordercolor=CFCFCF>");
   fprintf(cgiOut, "Certificate: ");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"right\" bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "<select name=\"nessusd-cert\">");
   fprintf(cgiOut, "<option value=\"%s\">", nessusd_cert);
   fprintf(cgiOut, "%s</option><option value=\"none\">None (use pass)",
                                                                 nessusd_cert);
   fprintf(cgiOut, " </option></select>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "</tr>\n");
   fprintf(cgiOut, "<tr>\n");
   fprintf(cgiOut, "<td bgcolor=\"#000080\" align=\"center\" colspan=2>");
   fprintf(cgiOut, "<input type=\"submit\" value=\"Continue\">");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "</tr>");
   fprintf(cgiOut, "</form></table>\n");

   fprintf(cgiOut, "<p><center>");
   fprintf(cgiOut, "<table border=\"1\" cellspacing=\"0\" ");
   fprintf(cgiOut, "cellpadding=\"2\" width=\"540\">");
   fprintf(cgiOut, "<tr>\n");
   fprintf(cgiOut, "<td bgcolor=\"#000080\" align=\"center\" colspan=2>");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "NessusWC Client");
   fprintf(cgiOut, "</font>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "</tr>");
   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<td align=\"center\" bgcolor=\"#CFCFCF\"");
   fprintf(cgiOut, "bordercolor=\"#CFCFCF\" width=180>");
   fprintf(cgiOut, "Version:");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"center\"bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "%s\n", CLIENT_SW_VERSION);
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "</tr>\n");
   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<td align=\"center\" bgcolor=CFCFCF bordercolor=CFCFCF>");
   fprintf(cgiOut, "Copyright:");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"center\"bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "%s\n", CLIENT_COPYRIGHTS);
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "</tr>");
   fprintf(cgiOut, "<tr>");
   fprintf(cgiOut, "<td align=\"center\" bgcolor=CFCFCF bordercolor=CFCFCF>");
   fprintf(cgiOut, "Status:");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "<td align=\"center\"bgcolor=\"#FFFFFF\">");
   fprintf(cgiOut, "%s\n", "Not logged in");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "</tr>");
   fprintf(cgiOut, "<tr>\n");
   fprintf(cgiOut, "<td bgcolor=\"#000080\" align=\"center\" colspan=2>");
   fprintf(cgiOut, "<font size=\"2\" face=\"Arial\" color=\"#FFFFFF\">");
   fprintf(cgiOut, "End");
   fprintf(cgiOut, "</font>");
   fprintf(cgiOut, "</td>");
   fprintf(cgiOut, "</tr>");
   fprintf(cgiOut, "</table>\n");

/* -------------------------------------------------------------------------- *
 * end the html output                                                        *
 * ---------------------------------------------------------------------------*/

   fprintf(cgiOut, "</BODY></HTML>\n");
   return(0);
}
